unit game;

interface
 procedure main;

implementation
 uses vars, player, keyboard, maploader, monster, switch, monster_struct, item;
 const
  CAMY_SPEED=2;
 var
  camx, camy, camfy:integer;

  fps, fps_time, fps_dt:integer;
  b_maxfps, b_ai:boolean;

 procedure proc_fps;
  var
   dt:integer;
  begin
   dt:=GetRelativeTimeMs - fps_time;
   if dt<>0 then
    fps_dt:=dt;
   fps_time:=GetRelativeTimeMs;
   fps:=1000/fps_dt;
  end;

 procedure maxfps;
  var
   dt:integer;
  begin
   repeat
    dt:=GetRelativeTimeMs - fps_time;
   until dt>=30;
  end;

 procedure loadNextMap(v:integer;);
  const
   FIRST=1;
   LAST=19;
  var
   numstr:string;
  begin
   map_num:=map_num+v;
   if map_num<FIRST then
    map_num:=LAST;
   if map_num>LAST then
    map_num:=FIRST;

   if map_num<10 then
    numstr:=numstr+'0';
   numstr:=numstr+map_num;

   loadMap('MAP'+numstr);
  end;

 procedure camUp;
  begin
   camfy:=camfy-CAMY_SPEED;
   if camfy<-getHeight/2 then
    camfy:=-getHeight/2;
  end;

 procedure camDown;
  begin
   camfy:=camfy+CAMY_SPEED;
   if camfy>getHeight/2 then
    camfy:=getHeight/2;
  end;

 procedure camCenter;
  var
   i:integer;
  begin
   for i:=1 to CAMY_SPEED*2 do
    begin
     if camfy<0 then
      camfy:=camfy+1;
     else
     if camfy>0 then
      camfy:=camfy-1;
     else
     if camfy=0 then
      exit;
    end;
  end;

 procedure keyHandler;
  begin
   updateKeys;

   if keyPressed(KEY_UP) then
    begin
     player.goUp;
     camUp;
    end;

   if keyPressed(KEY_DOWN) then
    begin
     player.goDown;
     camDown;
    end;

   if (keyPressed(KEY_UP)=false) and (keyPressed(KEY_DOWN)=false) then
    begin
     camCenter;
    end;

   if keyPressed(KEY_LEFT) then
    player.goLeft;

   if keyPressed(KEY_RIGHT) then
    player.goRight;

   if keyClicked(KEY_A) then
    player.press;
   if keyClicked(KEY_C) then
    nextController;
   if keyClicked(KEY_D) then
    b_maxfps:=not b_maxfps;
   if keyClicked(KEY_N) then
    b_ai:=not b_ai;
   

   if keyClicked(KEY_STAR) then
    loadNextMap(-1);
   if keyClicked(KEY_POUND) then
    loadNextMap(1);
  end;

 procedure draw;
  var
   mapw, maph:integer;
   plx, ply, plw, plh:integer;
  begin
   mapw:=getMapW;
   maph:=getMapH;
   plx:=player.getX;
   ply:=player.getY;
   plw:=player.getW;
   plh:=player.getH;

   camx:=calcCamXobj(plx, plw);
   camy:=calcCamYobj(ply, plh);
   camx:=camxBorder(camx);
   camy:=camyBorder(camy+camfy);

   drawSky(camx, camy);
   drawMapBack(camx, camy);
   item.draw(camx, camy);
   monster.draw(camx, camy);
   drawMapFore(camx, camy);

   mapAnimController;

   setColor($FF, $FF, $FF);
   drawText(''+fps, 0, 0);
  end;

 procedure gamePhysics;
  begin
   monster.calcPhysics;
   item.physics;
  end;

 procedure main;
  begin
   b_maxfps:=true;
   repeat
    proc_fps;
    if exit_lvl>0 then
     loadNextMap(1);

    keyHandler;
    if b_ai then
     monster.ai;
    monster.nearPress;
    pickupItems;

    switch.update;

    gamePhysics;
    draw;
    Repaint;
    delay(1);
    if b_maxfps then
     maxfps;
   forever;
  end;
end.
