unit item;

interface
 const
 I_NONE=0;
 I_CLIP=1;
 I_SHEL=2;
 I_ROCKET=3;
 I_CELL=4;
 I_AMMO=5;
 I_SBOX=6;
 I_RBOX=7;
 I_CELP=8;
 I_STIMI_MEDI=9;
 I_BPACK=10;
 I_CSAW=11;
 I_SGUN=12;
 I_SGUN2=13;
 I_MGUN=14;
 I_LAUN=15;
 I_PLAS=16;
 I_BFG=17;

 I_ARM1=18;
 I_ARM2=19;
 I_MEGA=20;
 I_INVL=21;
 I_AQUA=22;
 I_KEYR=23;
 I_KEYG=24;
 I_KEYB=25;
 I_SUIT=26;
 I_SUPER=27;

 I_RTORCH=28;//красный факел
 I_GTORCH=29;//зелёный факел
 I_BTORCH=30;//синий факел
 I_GOR1=31;//чувак
 I_FCAN=32;//горящая бочка
 I_GUN2=33;

 MAX_ITEM=300;
 I_TYPES=33;

 function getType(i:integer):integer;
 procedure delete(i:integer);
 function collision(x, y, w, h, i:integer):boolean;
 procedure reset;
 procedure add(_type, x, y:integer; can_fall:boolean);
 procedure physics;
 procedure draw(camx, camy:integer);

implementation
 uses phy, vars, texture;
 const
  ITEMW=10;
  ITEMH=8;

  F_FALL=1;
 var
  item_x, item_y, item_vy, item_type, item_flags: array [0..MAX_ITEM] of integer;

  item_img: array [0..I_TYPES] of integer;

 procedure loadTexture(_type:integer);
  begin
   if item_img[_type]=0 then
    if _type=I_CLIP then
     item_img[I_CLIP]:=texture.load('CLIPA0');
    else
    if _type=I_STIMI_MEDI then
     item_img[I_STIMI_MEDI]:=texture.load('STIMA0');
  end;

 function getFrame(i:integer):integer;
  begin
   getFrame:=item_img[item_type[i]];
  end;

 function getType(i:integer):integer;
  begin
   getType:=item_type[i];
  end;

 procedure delete(i:integer);
  begin
   item_type[i]:=I_NONE;
   item_vy[i]:=0;
   item_x[i]:=0;
   item_y[i]:=0;
   item_flags[i]:=0;
  end;

 function collision(x, y, w, h, i:integer):boolean;
  begin
   if item_type[i]<>I_NONE then
    if (item_x[i]+ITEMW>=x) and 
       (item_y[i]+ITEMH>=y) and 
       (item_x[i]<=x+w) and 
       (item_y[i]<=y+h) then
     collision:=true;
  end;
  
 procedure reset;
  var
   i:integer;
  begin
   for i:=0 to MAX_ITEM do
    delete(i);
   for i:=0 to I_TYPES do
    item_img[i]:=0;
  end;

 procedure add(_type, x, y:integer; can_fall:boolean);
  var
   i:integer;
  begin
   for i:=0 to MAX_ITEM do
    if item_type[i]=I_NONE then
     begin
      loadTexture(_type);
      item_type[i]:=_type;
      item_x[i]:=x;
      item_y[i]:=y;
      item_vy[i]:=0;
      if can_fall then
       item_flags[i]:=F_FALL;
      exit;
     end;
  end;

 procedure physics;
  var
   i:integer;
  begin 
   for i:=0 to MAX_ITEM do
    if item_type[i]<>I_NONE then
    if (item_flags[i] and F_FALL)>0 then
     begin
      phy.loadObject(item_x[i], item_y[i], TILE_SIZE, TILE_SIZE, 0, item_vy[i], false);
      phy.calc;
      item_x[i]:=phy.getX;
      item_y[i]:=phy.getY;
      item_vy[i]:=phy.getVelY;
     end;
  end;

 procedure draw(camx, camy:integer);
  var
   i:integer;
  begin 
   for i:=0 to MAX_ITEM do
    if item_type[i]<>I_NONE then
     begin
      {setColor($00, $00, $7F);
      fillRect(item_x[i]-camx, item_y[i]-camy, ITEMW, ITEMH);}
      drawImage(texture.pool[getFrame(i)], item_x[i]-camx, item_y[i]-camy);
     end;
  end;

initialization
 
end.
