unit keyboard;

interface
 const
  KEY_UP=0;
  KEY_DOWN=1;
  KEY_LEFT=2;
  KEY_RIGHT=3;
  KEY_FIRE=4;
  KEY_A=5;
  KEY_B=6;
  KEY_C=7;
  KEY_D=8;
  KEY_N=9;
  KEY_STAR=10;
  KEY_POUND=11;

 function keyClicked(keyType:integer):boolean;
 function keyPressed(keyType:integer):boolean;
 procedure updateKeys;

implementation
 uses keys;
 const
  MAX_KEY_TYPE=11;
  MAX_KEY_CODE=1;

  KEY_BIT_UP=2;
  KEY_BIT_DOWN=64;
  KEY_BIT_LEFT=4;
  KEY_BIT_RIGHT=32;
  KEY_BIT_FIRE=256;
  KEY_BIT_A=512;
  KEY_BIT_B=1024;
  KEY_BIT_C=2048;
  KEY_BIT_D=4096;
 var
  keyTable: array [0..MAX_KEY_TYPE, 0..MAX_KEY_CODE] of integer;
  keyBitTable: array [0..MAX_KEY_TYPE] of integer;
  clicked, pressed, keyBits:integer;

 function keyClicked(keyType:integer):boolean;
  var
   i:integer;
  begin

   if clicked<>0 then
   for i:=0 to MAX_KEY_CODE do
    if clicked=keyTable[keyType, i] then
     begin
      keyClicked:=true;
      exit;
     end;
  end;

 function keyPressed(keyType:integer):boolean;
  var
   i:integer;
  begin
   if (keyBits and keyBitTable[keyType])>0 then
    begin
     keyPressed:=true;
     exit;
    end;

   if pressed<>0 then
   for i:=0 to MAX_KEY_CODE do
    if pressed=keyTable[keyType, i] then
     begin
      keyPressed:=true;
      exit;
     end;
  end;

 procedure updateKeys;
  begin
   clicked:=getKeyClicked;
   pressed:=getKeyPressed;
   keyBits:=get_key_states;
  end;

initialization
 keyTable[KEY_UP, 0]:=-1;
 keyTable[KEY_UP, 1]:=50;

 keyTable[KEY_DOWN, 0]:=-2;
 keyTable[KEY_DOWN, 1]:=56;

 keyTable[KEY_LEFT, 0]:=-3;
 keyTable[KEY_LEFT, 1]:=52;

 keyTable[KEY_RIGHT, 0]:=-4;
 keyTable[KEY_RIGHT, 1]:=54;

 keyTable[KEY_FIRE, 0]:=-5;
 keyTable[KEY_FIRE, 1]:=53;

 keyTable[KEY_A, 0]:=49;
 keyTable[KEY_B, 0]:=51;
 keyTable[KEY_C, 0]:=55;
 keyTable[KEY_D, 0]:=57;
 keyTable[KEY_N, 0]:=48;
 keyTable[KEY_STAR, 0]:=42;
 keyTable[KEY_POUND, 0]:=35;

 //===========
 keyBitTable[KEY_UP]:=KEY_BIT_UP;
 keyBitTable[KEY_DOWN]:=KEY_BIT_DOWN;
 keyBitTable[KEY_LEFT]:=KEY_BIT_LEFT;
 keyBitTable[KEY_RIGHT]:=KEY_BIT_RIGHT;
 keyBitTable[KEY_FIRE]:=KEY_BIT_FIRE;
 keyBitTable[KEY_A]:=KEY_BIT_A;
 keyBitTable[KEY_B]:=KEY_BIT_B;
 keyBitTable[KEY_C]:=KEY_BIT_C;
 keyBitTable[KEY_D]:=KEY_BIT_D;
end.
