unit maploader;

interface
 procedure loadMap(name:string);

implementation
 uses vars, files, monster, switch, monster_struct, canvas, item, texture;

 function readUnsByte(res:resource):integer;
  begin
   readUnsByte:=readByte(res) and $FF;
  end;

 function readString(res:resource):string;
  var
   tmp:integer;
   tmpstr:string;
  begin
   repeat
    tmp:=readUnsByte(res);
    if tmp=$0A then
     break;

    tmpstr:=tmpstr+chr(tmp);
   forever;

   readString:=tmpstr;
  end;

 function readShortBIG(res:resource):integer;
  begin
   /*TODO: бит знака поставить на своё место*/
   //readShortBIG:=(tmp and $8000) or ((tmp and $8000)<<16);
   readShortBIG:=(readUnsByte(res)) or (readUnsByte(res)<<8);
  end;

 function readIntBIG(res:resource):integer;
  begin
   readIntBIG:=(readUnsByte(res)) or (readUnsByte(res)<<8) or (readUnsByte(res)<<16) or (readUnsByte(res)<<24);
  end;

 function cp866toUTF(str:string):string;
  var
   i, ch:integer;
   resstr:string;
  begin
   for i:=0 to length(str)-1 do
    begin
     ch:=ord(getChar(str, i));

     if (ch>=$80) and (ch<=$AF) then
      ch:=ch+$390;
     else
     if (ch>=$E0) and (ch<=$EF) then
      ch:=ch+$35F;
     else
     if ch=$F0 then
      ch:=$401;
     else
     if ch=$F1 then
      ch:=$451;

     resstr:=resstr+chr(ch);
    end;

   cp866toUTF:=resstr;
  end;

 function readBytesAsStr(res:resource; bytes:integer;):string;
  var
   i, tmp:integer;
   str:string;
  begin
   for i:=1 to bytes do
    begin
     tmp:=readUnsByte(res);
     if tmp=$00 then
      begin
       seekResource(res, bytes-i);
       break;
      end;
     str:=str+chr(tmp);
    end;

   readBytesAsStr:=str;
  end;

 procedure unPack(res:resource; size, _type:integer);
  var
   b, b2, i, t, j:integer;
  begin
   for i:=1 to size do
    begin
     b:=readUnsByte(res);
     if b=$FF then
      begin
       b:=readShortBIG(res);
       b2:=readUnsByte(res);
       for t:=j to j+b+1 do
        setFlatMapBack(b2, t, _type);
       i:=i+3;
       j:=j+b;
      end;
     else
      begin
       setFlatMapBack(b, j, _type);
       j:=j+1;
      end;
    end;
  end;

 procedure addMonster(_type, x, y, flags:integer; controller:boolean);
  const
   DIR_FLAG=$1;
  var
   id:integer;
  begin
   x:=x-monster_struct.getTabW(_type)/2;
   y:=y-monster_struct.getTabH(_type);
   id:=monster.spawn(_type, x, y);
   monster_struct.setPosi(flags and DIR_FLAG, id);
   if controller then
    controll_mn:=id;
  end;

 procedure addItem(_type, x, y, flags:integer; can_fall:boolean);
  const
   DM_FLAG=$10;
  begin
   if (flags and DM_FLAG)=0 then
    item.add(_type, x-TILE_SIZE/2, y-TILE_SIZE, can_fall);
  end;

 procedure loadThings(res:resource; size:integer;);
  var
   x, y, _type, flags, i:integer;
  begin
   while i<size do
    begin
     x:=readShortBIG(res);
     y:=readShortBIG(res);
     _type:=readShortBIG(res);
     flags:=readShortBIG(res);
     i:=i+8;
     if _type=1 then
      addMonster(MN_PLAYER, x, y, flags, true);
     else

     if _type=100 then
      addItem(I_CLIP, x, y, flags, false);
     else
     if _type=101 then
      addItem(I_SHEL, x, y, flags, false);
     else
     if _type=102 then
      addItem(I_CLIP, x, y, flags, false);
     else
     if _type=103 then
      addItem(I_CELL, x, y, flags, false);
     else
     if _type=104 then
      addItem(I_AMMO, x, y, flags, false);
     else
     if _type=105 then
      addItem(I_SBOX, x, y, flags, false);
     else
     if _type=106 then
      addItem(I_RBOX, x, y, flags, false);
     else
     if _type=107 then
      addItem(I_CELP, x, y, flags, false);
     else
     if _type=108 then
      addItem(I_STIMI_MEDI, x, y, flags, false);
     else
     if _type=109 then
      addItem(I_BPACK, x, y, flags, false);
     else
     if _type=110 then
      addItem(I_CSAW, x, y, flags, false);
     else
     if _type=111 then
      addItem(I_SGUN, x, y, flags, false);
     else
     if _type=112 then
      addItem(I_SGUN2, x, y, flags, false);
     else
     if _type=113 then
      addItem(I_MGUN, x, y, flags, false);
     else
     if _type=114 then
      addItem(I_LAUN, x, y, flags, false);
     else
     if _type=115 then
      addItem(I_PLAS, x, y, flags, false);
     else
     if _type=116 then
      addItem(I_BFG, x, y, flags, false);
     else
     if _type=117 then
      addItem(I_ARM1, x, y, flags, false);
     else
     if _type=118 then
      addItem(I_ARM2, x, y, flags, false);
     else
     if _type=119 then
      addItem(I_MEGA, x, y, flags, false);
     else
     if _type=120 then
      addItem(I_INVL, x, y, flags, false);
     else
     if _type=121 then
      addItem(I_AQUA, x, y, flags, false);
     else
     if _type=122 then
      addItem(I_KEYR, x, y, flags, true);
     else
     if _type=123 then
      addItem(I_KEYG, x, y, flags, true);
     else
     if _type=124 then
      addItem(I_KEYB, x, y, flags, true);
     else
     if _type=125 then
      addItem(I_SUIT, x, y, flags, false);
     else
     if _type=126 then
      addItem(I_SUPER, x, y, flags, false);
     else
    

     if _type=200 then
      addMonster(MN_DEMON, x, y, flags, false);
     else
     if _type=201 then
      addMonster(MN_IMP, x, y, flags, false);
     else
     if _type=202 then
      addMonster(MN_ZOMBY, x, y, flags, false);
     else
     if _type=203 then
      addMonster(MN_SERG, x, y, flags, false);
     else
     if _type=204 then
      addMonster(MN_CYBER, x, y, flags, false);
     else
     if _type=205 then
      addMonster(MN_CGUN, x, y, flags, false);
     else
     if _type=206 then
      addMonster(MN_BARON, x, y, flags, false);
     else
     if _type=207 then
      addMonster(MN_KNIGHT, x, y, flags, false);
     else
     if _type=208 then
      addMonster(MN_CACO, x, y, flags, false);
     else
     if _type=209 then
      addMonster(MN_SOUL, x, y, flags, false);
     else
     if _type=210 then
      addMonster(MN_PAIN, x, y, flags, false);
     else
     if _type=211 then
      addMonster(MN_SPIDER, x, y, flags, false);
     else
     if _type=212 then
      addMonster(MN_BSP, x, y, flags, false);
     else
     if _type=213 then
      addMonster(MN_MANCUB, x, y, flags, false);
     else
     if _type=214 then
      addMonster(MN_SKEL, x, y, flags, false);
     else
     if _type=215 then
      addMonster(MN_VILE, x, y, flags, false);
     else
     if _type=216 then
      addMonster(MN_FISH, x, y, flags, false);
     else
     if _type=217 then
      addMonster(MN_BARREL, x, y, flags, false);
     else
     if _type=218 then
      addMonster(MN_ROBO, x, y, flags, false);
     else
     if _type=219 then
      addMonster(MN_MAN, x, y, flags, false);
     else
    end;
  end;

 procedure loadSwitch(res:resource; size:integer;);
  var
   x, y, _type, tm, a, b, c, flags, i:integer;
  begin
   while i<size do
    begin
     x:=readUnsByte(res)*TILE_SIZE;
     y:=readUnsByte(res)*TILE_SIZE;
     _type:=readUnsByte(res);
     tm:=readUnsByte(res);
     a:=readUnsByte(res);
     b:=readUnsByte(res);
     c:=readShortBIG(res);
     flags:=readUnsByte(res);
     debug('SW x:'+x+' y:'+y+' t:'+_type+' tm:'+tm+' a:'+a+' b:'+b+' c:'+c+' f:'+flags);
     i:=i+9;
     addSwitch(_type, x, y, a, b, flags);
    end;
  end;

 procedure loadMap(name:string);
  const
   MAPW=99;
   MAPH=99;
  var
   res:resource;
   ver:integer;
   btype, subtype, size, i, j:integer;
   tmp, _scr, _img:integer;
   str:string;

   texpool_id:integer;
  begin
   res:=openResource('/'+name);
   if readBytesAsStr(res, 6)='Doom2D' then
    debug('Yey! Its "Doom2D"');
   if (readUnsByte(res)=$1A) then
    debug('Okey, it last doom2d map version');
   tmp:=readByte(res);
   ver:=readShortBIG(res);

   resetMap(MAPW+1, MAPH+1);
   texture.resetAll;
   monster_struct.resetAll;
   switch.resetAll;
   vars.resetTextureData;
   exit_lvl:=0;
   item.reset;

   repeat
    btype:=readShortBIG(res);
    subtype:=readShortBIG(res);
    size:=readIntBIG(res);

    debug('type: '+btype+' sub: '+subtype+' size: '+size);

    if btype=0 then
     break;
    else
    if btype=1 then
     begin
      i:=0;
      while i<size do
       begin
        i:=i+9;
        texpool_id:=texpool_id+1;
        str:=UpCase(cp866toUTF(readBytesAsStr(res, 8)));
        tmp:=readByte(res);
        debug('LOAD TEXTURE "'+str+'"');
        setTexture(vars.loadTexture(str), vars.getTexMaxDel(str),texpool_id);
       end;
     end;
    else
    if btype=2 then
     unPack(res, size, T_MAPBACK);
    else
    if btype=3 then
     unPack(res, size, T_MAPTYPE);
    else
    if btype=4 then
     unPack(res, size, T_MAPFORE);
    else
    if btype=5 then
     loadThings(res, size);
    else
    if btype=7 then
     debug('MUSIC "'+cp866toUTF(readBytesAsStr(res, size))+'"');
    else
    if btype=8 then
     begin
      tmp:=readShortBIG(res);
      debug('SKY '+tmp);
      sky:=loadImage('/RSKY'+tmp+'.png');

      if getWidth>getHeight then
       _scr:=getWidth;
      else
       _scr:=getHeight;

      if getImageWidth(sky)>getImageHeight(sky) then
       _img:=getImageWidth(sky);
      else
       _img:=getImageHeight(sky);

      tmp:=_scr/_img;
      if (_scr mod _img)>0 then
       tmp:=tmp+1;

      sky:=resize_image(sky, getImageWidth(sky)*tmp, getImageHeight(sky)*tmp);
     end;
    else
    if btype=9 then
     loadSwitch(res, size);
    else
     seekResource(res, size);

   forever;
  end;

end.
