unit monster;

interface
 var
  controll_mn:integer;

 function spawn(_type, x, y:integer):integer;
 procedure calcPhysics;

 procedure initTab;

 procedure toUp(i:integer);
 procedure toDown(i:integer);
 procedure toLeft(i:integer);
 procedure toRight(i:integer);
 procedure press(i:integer);
 procedure nearPress;

 procedure nextController;
 procedure ai;

 procedure draw(camx, camy:integer);

 procedure pickupItems;

implementation
 uses phy, switch, monster_struct, player, item;
 const
  STD_FLAGS=$0A;//SW_MN_PRESS|SW_MN_NEAR
  MAN_FLAGS=$1A;//SW_MN_PRESS|SW_MN_NEAR|SW_KEY_R
  PLR_FLAGS=$05;//SW_PL_PRESS|SW_PL_NEAR

  F_CAN_PICKUP=$1;

  STD_MONSTER=$0;
  STD_PLAYER=$1;

 {rad  ht  life  pain rv jv  slop min_pn
    0,  0,    0,    0, 0, 0,    0,    0,	// none
   15, 28,   60,   20, 7,10,	  0,   10,	// demon
   10, 28,   25,   15, 3,10,   30,    0,	// imp
   10, 28,   15,   10, 3,10,   30,    0,	// zomby
   10, 28,   20,   10, 3,10,   30,    0,	// sergeant
   20, 55,  500,   70, 5,10,   	0,   50,	// cyberdemon
   12, 28,   60,   20, 3,10,   30,   10,	// chaingunner
   12, 32,  150,   40, 3,10,    0,   30, 	// baron of hell
   12, 32,   75,   40, 3,10,    0,   30, 	// hell knight
   15, 28,  100,   10, 4, 4,    0,    0,	// cacodemon
    8, 18,   60,   10, 4, 4,    0,    0,	// lost soul
   15, 28,  100,   10, 4, 4,    0,    0,	// pain elemental
   64, 50,  500,   70, 4,10,    0,   50,	// spider mastermind
   25, 27,  150,   20, 4,10,    0,    0,	// arachnotron
   18, 30,  200,   40, 3, 7,    0,   20,	// mancubus
   17, 36,  200,   40, 6,11,    0,   20,	// revenant
   17, 36,  150,   30, 7,12,    0,   10,	// archvile
    5,  5,   35,   20,14, 6,    0,   10,	// fish
    5, 17,   20,    0, 7, 6,    0,    0,	// barrel
   17, 38,   20,   40, 3, 6,    0,   20,	// robot
    8, 26,  400,   70, 8,10,   30,   50		// man}

 procedure initTab;
  begin
   //          Type         w   h  life  speed  jspeed  access_flags    mon flags 
   initTabCell(MN_NONE,     0,  0,    0,     0,      0,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_DEMON,   31, 28,   60,     7,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_IMP,     21, 28,   25,     3,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_ZOMBY,   21, 28,   15,     3,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_SERG,    21, 28,   20,     3,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_CYBER,   41, 55,  500,     5,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_CGUN,    25, 28,   60,     3,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_BARON,   25, 35,  150,     3,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_KNIGHT,  25, 35,   75,     3,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_CACO,    31, 28,  100,     4,      4,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_SOUL,    17, 18,   60,     4,      4,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_PAIN,    31, 28,  100,     4,      4,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_SPIDER, 129, 50,  500,     4,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_BSP,     51, 27,  150,     4,     10,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_MANCUB,  37, 30,  200,     3,      7,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_SKEL,    35, 36,  200,     6,     11,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_VILE,    35, 36,  150,     7,     12,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_FISH,    11,  5,   35,    14,      6,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_BARREL,  11, 17,   20,     0,      0,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_ROBO,    35, 38, 9999,     3,      6,    STD_FLAGS, STD_MONSTER);
   initTabCell(MN_MAN,     17, 26,  400,     8,     10,    MAN_FLAGS, STD_MONSTER);
   initTabCell(MN_PLAYER,  17, 24,  100,  {8}5,     10,    PLR_FLAGS,  STD_PLAYER);
  end;

 function spawn(_type, x, y:integer):integer;
  var
   i:integer;
  begin
   for i:=0 to MAX_MN do
   if monster_struct.getType(i)=MN_NONE then
    begin
     monster_struct.setType(_type, i);
     monster_struct.setX(x, i);
     monster_struct.setY(y, i);
     monster_struct.setVelX(0, i);
     monster_struct.setVelY(0, i);
     monster_struct.setJmp(false, i);
     monster_struct.setAccessFlags(getTabAccess(_type), i);
     debug('Spawn monster type:'+_type+' x:'+x+' y:'+y);
     spawn:=i;
     exit;
    end;

   spawn:=-1;
  end;

 procedure nextController;
  var
   i:integer;
  begin
   for i:=controll_mn+1 to MAX_MN do
   if monster_struct.getType(i)<>MN_NONE then
    begin
     controll_mn:=i;
     exit;
    end;

   for i:=0 to MAX_MN do
   if monster_struct.getType(i)<>MN_NONE then
    begin
     controll_mn:=i;
     exit;
    end;
  end;

 procedure loadMNphy(i:integer);
  begin
   phy.loadObject(monster_struct.getX(i),
                  monster_struct.getY(i),
                  monster_struct.getW(i),
                  monster_struct.getH(i),
                  monster_struct.getVelX(i),
                  monster_struct.getVelY(i),
                  monster_struct.getJmp(i));
  end;

 procedure storeMNphy(i:integer);
  begin
   monster_struct.setX(phy.getX, i);
   monster_struct.setY(phy.getY, i);
   monster_struct.setVelX(phy.getVelX, i);
   monster_struct.setVelY(phy.getVelY, i);
   monster_struct.setJmp(phy.getJmp, i);
  end;

 procedure calcPhysics;
  var
   i:integer;
  begin
   for i:=0 to MAX_MN do
    if monster_struct.getType(i)<>MN_NONE then
     begin
      loadMNphy(i);
      phy.calc;
      storeMNphy(i);
     end;
  end;

 procedure toUp(i:integer);
  begin
   loadMNphy(i);
   phy.jumpObj(getJmpS(i));
   storeMNphy(i);
  end;

 procedure toDown(i:integer);
  begin

  end;

 procedure toLeft(i:integer);
  begin
   setVelX(-getSpeed(i), i);
   setPosi(0, i);
  end;

 procedure toRight(i:integer);
  begin
   setVelX(getSpeed(i), i);
   setPosi(1, i);
  end;

 procedure press(i:integer);
  const
   PRESS_MASK=$73;//SW_MN_PRESS|SW_PL_PRESS|KEYS_MASK
  begin
   pressSwitch(monster_struct.getX(i),
               monster_struct.getY(i),
               monster_struct.getW(i),
               monster_struct.getH(i),
               monster_struct.getAccessFlags(i) and PRESS_MASK,
               i);
  end;

 procedure ai;
  var
   i, x, y, w, h, enx, eny, enw, enh:integer;
  begin
   for i:=0 to MAX_MN do
    if (monster_struct.getType(i)<>MN_NONE) and (i<>controll_mn) then
     begin
      x:=monster_struct.getX(i);
      y:=monster_struct.getY(i);
      w:=monster_struct.getW(i);
      h:=monster_struct.getH(i);
      enx:=player.getX;
      eny:=player.getY;
      enw:=player.getW;
      enh:=player.getH;
      if getStat(i)=SLEEP then
       begin
        if (enx-x<0) and (getPosi(i)=0) or (enx-x>0) and (getPosi(i)=1) then
        if canSeeObj(x+w/2, y+h/2, enx+enw/2, eny+enh/2) then
          monster_struct.setStat(GO, i);
       end;
      else
       begin
        if random(20)=random(20) then
         toLeft(i);
        else
        if random(20)=random(20) then
         toRight(i);
        else
         begin
          if getPosi(i)=0 then
           toLeft(i);
          else
           toRight(i);
         end;

        if random(20)=random(20) then
         toUp(i);

        if random(30)=random(30) then
         press(i);
       end;

     end;
  end;

 procedure nearPress;
  const
   NEAR_MASK=$7C;//SW_MN_NEAR|SW_PL_NEAR|KEYS_MASK
  var
   i:integer;
  begin
   for i:=0 to MAX_MN do
    if (monster_struct.getType(i)<>MN_NONE) then
   pressSwitch(monster_struct.getX(i),
               monster_struct.getY(i),
               monster_struct.getW(i),
               monster_struct.getH(i),
               monster_struct.getAccessFlags(i) and NEAR_MASK,
               i);
  end;

 procedure getItem(i, item_id:integer);
  begin
   delete(item_id);
  end;

 procedure pickupItems;
  var
   i, j:integer;
  begin
   for i:=0 to MAX_MN do
    if monster_struct.getType(i)<>MN_NONE then
    if (monster_struct.getMonFlags(i) and F_CAN_PICKUP)>0 then
     begin
      for j:=0 to MAX_ITEM do
       if collision(monster_struct.getX(i), 
                    monster_struct.getY(i), 
                    monster_struct.getW(i), 
                    monster_struct.getH(i), j) then
       getItem(i, j);
     end;
  end;

 procedure draw(camx, camy:integer);
  var
   i:integer;
   x, y, w, h:integer;
  begin
   for i:=0 to MAX_MN do
   if monster_struct.getType(i)<>MN_NONE then
    begin
     x:=monster_struct.getX(i)-camx;
     y:=monster_struct.getY(i)-camy;
     w:=monster_struct.getW(i);
     h:=monster_struct.getH(i);
     setColor($7F, $00, $00);
     fillRect(x, y, w, h);

     setColor($FF, $FF, $FF);
     fillRect(x+w/2-1, y+h/2-1, 3, 3);
     if monster_struct.getPosi(i)=0 then
      drawLine(x+w/2, y+h/2, x+w/2-8, y+h/2);
     else
      drawLine(x+w/2, y+h/2, x+w/2+8, y+h/2);
    end;
  end;

initialization
 
end.
