unit monster_struct;

interface
 const
  MN_NONE=0;
  MN_DEMON=1;
  MN_IMP=2;
  MN_ZOMBY=3;
  MN_SERG=4;
  MN_CYBER=5;
  MN_CGUN=6;
  MN_BARON=7;
  MN_KNIGHT=8;
  MN_CACO=9;
  MN_SOUL=10;
  MN_PAIN=11;
  MN_SPIDER=12;
  MN_BSP=13;
  MN_MANCUB=14;
  MN_SKEL=15;
  MN_VILE=16;
  MN_FISH=17;
  MN_BARREL=18;
  MN_ROBO=19;
  MN_MAN=20;
  MN_PLAYER=21;

  SLEEP=0;
  GO=1;
  RUN=2;
  CLIMB=3;
  DIE=4;
  DEAD=5;
  ATTACK=6;
  SHOOT=7;
  PAIN=8;
  WAIT=9;
  REVIVE=10;
  RUNOUT=11;

  MAX_MN=200;

  MAX_MONTAB=21;

 procedure setType(value, i:integer);
 function getType(i:integer):integer;
 procedure setX(value, i:integer);
 function getX(i:integer):integer;
 procedure setY(value, i:integer);
 function getY(i:integer):integer;
 function getW(i:integer):integer;
 function getH(i:integer):integer;
 procedure setVelX(value, i:integer);
 function getVelX(i:integer):integer;
 procedure setVelY(value, i:integer);
 function getVelY(i:integer):integer;
 procedure setJmp(value:boolean; i:integer);
 function getJmp(i:integer):boolean;
 function getJmpS(i:integer):integer;
 function getSpeed(i:integer):integer;
 function getAccessFlags(i:integer):integer;
 procedure setAccessFlags(value, i:integer);
 function getPosi(i:integer):integer;
 procedure setPosi(value, i:integer);
 procedure setStat(value, i:integer);
 function getStat(i:integer):integer;
 function getMonFlags(i:integer):integer;

 function getTabW(_type:integer):integer;
 function getTabH(_type:integer):integer;
 function getTabAccess(_type:integer):integer;
 function getTabMonFlags(_type:integer):integer;

 procedure initTabCell(_type, w, h, life, speed, jspeed, a_flags, m_flags:integer);
 procedure resetAll;

implementation
 var
  mon_type, mon_x, mon_y, mon_vx, mon_vy, mon_flags, mon_posi, mon_stat: array [0..MAX_MN] of integer;
  mon_jmp: array [0..MAX_MN] of boolean;

  //inv_weap: array [0..MAX_MN, 0..MAX_WEAP_TYPE] of integer;
  //inv_ammo: array [0..MAX_MN, 0..MAX_AMMO_TYPE] of integer;

  montab_w, montab_h, montab_life, montab_speed, montab_jmp, montab_a_flags, montab_m_flags: array [0..MAX_MONTAB] of integer;

 procedure initTabCell(_type, w, h, life, speed, jspeed, a_flags, m_flags:integer);
  begin
   montab_w[_type]:=w;
   montab_h[_type]:=h;
   montab_life[_type]:=life;
   montab_speed[_type]:=speed;
   montab_jmp[_type]:=jspeed;
   montab_a_flags[_type]:=a_flags;
   montab_m_flags[_type]:=m_flags;
  end;

 function getTabW(_type:integer):integer;
  begin
   getTabW:=montab_w[_type];
  end;

 function getTabAccess(_type:integer):integer;
  begin
   getTabAccess:=montab_a_flags[_type];
  end;

 function getTabMonFlags(_type:integer):integer;
  begin
   getTabMonFlags:=montab_m_flags[_type];
  end;

 function getTabH(_type:integer):integer;
  begin
   getTabH:=montab_h[_type];
  end;

 function getTabLife(_type:integer):integer;
  begin
   getTabLife:=montab_life[_type];
  end;

 function getTabSpeed(_type:integer):integer;
  begin
   getTabSpeed:=montab_speed[_type];
  end;

 function getTabJmp(_type:integer):integer;
  begin
   getTabJmp:=montab_jmp[_type];
  end;

 function getType(i:integer):integer;
  begin
   getType:=mon_type[i];
  end;

 procedure setType(value, i:integer);
  begin
   mon_type[i]:=value;
  end;

 function getAccessFlags(i:integer):integer;
  begin
   getAccessFlags:=mon_flags[i];
  end;

 function getMonFlags(i:integer):integer;
  begin
   getMonFlags:=montab_m_flags[mon_type[i]];
  end;

 procedure setAccessFlags(value, i:integer);
  begin
   mon_flags[i]:=value;
  end;

 function getPosi(i:integer):integer;
  begin
   getPosi:=mon_posi[i];
  end;

 procedure setPosi(value, i:integer);
  begin
   mon_posi[i]:=value;
  end;

 procedure setX(value, i:integer);
  begin
   mon_x[i]:=value;
  end;

 function getX(i:integer):integer;
  begin
   getX:=mon_x[i];
  end;

 procedure setY(value, i:integer);
  begin
   mon_y[i]:=value;
  end;

 function getY(i:integer):integer;
  begin
   getY:=mon_y[i];
  end;

 function getW(i:integer):integer;
  begin
   getW:=montab_w[mon_type[i]];
  end;

 function getH(i:integer):integer;
  begin
   getH:=montab_h[mon_type[i]];
  end;

 function getSpeed(i:integer):integer;
  begin
   getSpeed:=montab_speed[mon_type[i]];
  end;

 function getJmpS(i:integer):integer;
  begin
   getJmpS:=montab_jmp[mon_type[i]];
  end;

 procedure setVelX(value, i:integer);
  begin
   mon_vx[i]:=value;
  end;

 function getVelX(i:integer):integer;
  begin
   getVelX:=mon_vx[i];
  end;

 procedure setVelY(value, i:integer);
  begin
   mon_vy[i]:=value;
  end;

 function getVelY(i:integer):integer;
  begin
   getVelY:=mon_vy[i];
  end;

 procedure setJmp(value:boolean; i:integer);
  begin
   mon_jmp[i]:=value;
  end;

 function getJmp(i:integer):boolean;
  begin
   getJmp:=mon_jmp[i];
  end;

 procedure setStat(value, i:integer);
  begin
   mon_stat[i]:=value;
  end;

 function getStat(i:integer):integer;
  begin
   getStat:=mon_stat[i];
  end;

 procedure resetAll;
  var
   i:integer;
  begin
   for i:=0 to MAX_MN do
    begin
     mon_type[i]:=MN_NONE;
     mon_x[i]:=0;
     mon_y[i]:=0;
     mon_vx[i]:=0;
     mon_vy[i]:=0;
     mon_jmp[i]:=false;
     mon_flags[i]:=0;
     mon_posi[i]:=0;
     mon_stat[i]:=SLEEP;
    end;
  end;

end.
