unit vars;

interface
 const
  TILE_SIZE=8;

  T_MAPBACK=0;
  T_MAPTYPE=1;
  T_MAPFORE=2;

  MAPTYPE_NONE=0;
  MAPTYPE_WALL=1;
  MAPTYPE_CDOOR=2;
  MAPTYPE_ODOOR=3;
  MAPTYPE_STEP=4;
  MAPTYPE_WATER1=5;
  MAPTYPE_WATER2=6;
  MAPTYPE_WATER3=7;
  MAPTYPE_BLMON=8;
  MAPTYPE_LIFTU=9;
  MAPTYPE_LIFTD=10;
 var
  sky:image;
  map_num:integer;
  exit_lvl:integer;

 procedure setMapBack(_tex, x, y:integer);
 function getMapBack(x, y:integer):integer;
 procedure setFlatMapBack(_tex, i, _type:integer);

 procedure setMap(id, x, y:integer);
 function getMap(x, y:integer):integer;
 procedure setMapFore(_tex, x, y:integer);
 function getMapFore(x, y:integer):integer;

 procedure resetMap(x, y:integer);
 function getMapW:integer;
 function getMapH:integer;

 function calcCamXobj(x, w:integer;):integer;
 function calcCamYobj(y, h:integer;):integer;
 function camxBorder(camx:integer):integer;
 function camyBorder(camy:integer):integer;

 procedure drawTex(id, x, y:integer);
 procedure drawMapBack(camx, camy:integer);
 procedure drawMapFore(camx, camy:integer);
 procedure drawSky(camx, camy:integer);

 procedure setTexture(texid, del, id:integer);
 function getTexMaxDel(name:string):integer;
 function loadTexture(name:string):integer;
 procedure mapAnimController;
 procedure resetTextureData;

implementation
 uses texture;
 var
  mapw, maph:integer;

  maxtxw, maxtxh:integer;
  mtx, mty:integer;//На сколько ячеек надо отрисовать за экраном, что бы текстуры магическим образом не исчезали.

  mapBack: array [0..0, 0..0] of integer;
  mapType: array [0..0, 0..0] of integer;
  mapFore: array [0..0, 0..0] of integer;

  mapTex: array [0..255] of integer;
  mapTexMaxDel: array [0..255] of integer;
  mapTexDel: array [0..255] of integer;

  procedure testSize(sw, sh:integer);
   begin
    if maxtxw<sw then
     begin
      maxtxw:=sw;
      mtx:=maxtxw/TILE_SIZE;
     end;
    if maxtxh<sh then
     begin
      maxtxh:=sh;
      mty:=maxtxh/TILE_SIZE;
     end;
   end;

 function getTexMaxDel(name:string):integer;
  begin
   if name='WALL58_1' then
    getTexMaxDel:=2;
  end;

 function loadTexture(name:string):integer;
  var
   tex_id, tmp1_id, tmp2_id:integer;
  begin
   if name='WALL58_1' then
    begin
     tex_id:=texture.load('WALL58_1');
     tmp1_id:=texture.load('WALL58_2');
     tmp2_id:=texture.load('WALL58_3');

     texture.setNext(tmp1_id, tex_id);
     texture.setNext(tmp2_id, tmp1_id);
     texture.setNext(tex_id, tmp2_id);
    end;
   else
    begin
     tex_id:=texture.load(name);
     texture.setNext(0, tex_id);
    end;

   loadTexture:=tex_id;
  end;

 procedure resetTextureData;
  var
   i:integer;
  begin
   maxtxw:=0;
   maxtxh:=0;
   mtx:=0;
   mty:=0;

   for i:=0 to 255 do 
    begin
     mapTex[i]:=0;
     mapTexMaxDel[i]:=0;
     mapTexDel[i]:=0;
    end;
  end;

 procedure setTexture(texid, del, id:integer);
  begin
   testSize(getImageWidth(texture.pool[texid]), getImageHeight(texture.pool[texid]));
   mapTex[id]:=texid;
   mapTexMaxDel[id]:=del;
   mapTexDel[id]:=0;
  end;

 procedure resetMap(x, y:integer);
  begin
   mapw:=x;
   maph:=y;
   x:=x+1;
   y:=y+1;
   bytecode
    iload 0;
    iload 1;
    multianewarray class '[[I', 2;
    putstatic field 'vars', 'mapback', '[[I';
   end;
   bytecode
    iload 0;
    iload 1;
    multianewarray class '[[I', 2;
    putstatic field 'vars', 'maptype', '[[I';
   end;
   bytecode
    iload 0;
    iload 1;
    multianewarray class '[[I', 2;
    putstatic field 'vars', 'mapfore', '[[I';
   end;
  end;

 function getMapW:integer;
  begin
   getMapW:=mapw;
  end;

 function getMapH:integer;
  begin
   getMapH:=maph;
  end;

 procedure setMapBack(_tex, x, y:integer);
  begin
   if (x>=0) and (y>=0) and (x<=MAPW) and (y<=MAPH) then
    mapBack[x, y]:=_tex;
  end;

 function getMapBack(x, y:integer):integer;
  begin
   if (x>=0) and (y>=0) and (x<=MAPW) and (y<=MAPH) then
    getMapBack:=mapBack[x, y];
  end;

 procedure setFlatMapBack(_tex, i, _type:integer);
  var
   x, y:integer;
  begin
   y:=i div mapw;
   x:=i - y*mapw;

   if _type=T_MAPBACK then
    setMapBack(_tex, x, y);
   else
   if _type=T_MAPTYPE then
    setMap(_tex, x, y);
   else
   if _type=T_MAPFORE then
    setMapFore(_tex, x, y);
  end;

 procedure setMapFore(_tex, x, y:integer);
  begin
   if (x>=0) and (y>=0) and (x<=MAPW) and (y<=MAPH) then
    mapFore[x, y]:=_tex;
  end;

 function getMapFore(x, y:integer):integer;
  begin
   if (x>=0) and (y>=0) and (x<=MAPW) and (y<=MAPH) then
    getMapFore:=mapFore[x, y];
  end;

 procedure setMap(_type, x, y:integer);
  begin
   if (x>=0) and (y>=0) and (x<=MAPW) and (y<=MAPH) then
    mapType[x, y]:=_type;
  end;

 function getMap(x, y:integer):integer;
  begin
   if (x>=0) and (y>=0) and (x<=MAPW) and (y<=MAPH) then
    getMap:=mapType[x, y];
  end;

 function calcCamXobj(x, w:integer;):integer;
  begin
   calcCamXobj:=x+w/2-getWidth/2;
  end;

 function calcCamYobj(y, h:integer;):integer;
  begin
   calcCamYobj:=y+h/2-getHeight/2;
  end;

 function camxBorder(camx:integer):integer;
  begin
   if camx<0 then
    camx:=0;
   if camx>MAPW*TILE_SIZE-getWidth then
    camx:=MAPW*TILE_SIZE-getWidth;

   camxBorder:=camx;
  end;

 function camyBorder(camy:integer):integer;
  begin
   if camy<0 then
    camy:=0;
   if camy>MAPH*TILE_SIZE-getHeight then
    camy:=MAPH*TILE_SIZE-getHeight;

   camyBorder:=camy;
  end;

 procedure drawTex(id, x, y:integer);
  var
   next:integer;
  begin
   if id>0 then 
    begin
     drawImage(texture.pool[mapTex[id]], x, y);
    end;
  end;

 procedure mapAnimController;
  var
   i, id, tex:integer;
  begin
   for i:=0 to 255 do
    begin
     id:=texture.getNext(mapTex[i]);
     if id<>0 then
      begin
       mapTexDel[i]:=mapTexDel[i]+1;
       if mapTexDel[i]>mapTexMaxDel[i] then
        begin
         mapTex[i]:=id;
         mapTexDel[i]:=0;
        end;
      end;
    end;
  end;

 procedure drawMapBack(camx, camy:integer);
  var
   mapw, maph:integer;
   minx, miny, maxx, maxy:integer;
   i, j, id:integer;
  begin
   minx:=camx/TILE_SIZE;
   miny:=camy/TILE_SIZE;
   maxx:=(camx+getWidth)/TILE_SIZE;
   maxy:=(camy+getHeight)/TILE_SIZE;
   if minx<0 then
    minx:=0;
   if maxx>mapw then
    minx:=mapw;
   if miny<0 then
    miny:=0;
   if maxy>maph then
    miny:=maph;

   for i:=minx to maxx do
   for j:=miny to maxy do
    begin
     id:=getMapBack(i, j);
     drawTex(id, i*TILE_SIZE-camx, j*TILE_SIZE-camy);
    end;
  end;

 procedure drawMapFore(camx, camy:integer);
  var
   mapw, maph:integer;
   minx, miny, maxx, maxy:integer;
   i, j, id:integer;
  begin
   mapw:=getMapW;
   maph:=getMapH;

   minx:=(camx/TILE_SIZE)-mtx;
   miny:=(camy/TILE_SIZE)-mty;
   maxx:=(camx+getWidth)/TILE_SIZE;
   maxy:=(camy+getHeight)/TILE_SIZE;

   if minx<0 then
    minx:=0;
   if miny<0 then
    miny:=0;
   if maxx>mapw then
    maxx:=mapw;
   if maxy>maph then
    maxy:=maph;

   for i:=minx to maxx do
   for j:=miny to maxy do
    begin
     id:=getMapFore(i, j);
     drawTex(id, i*TILE_SIZE-camx, j*TILE_SIZE-camy);
    end;
  end;

 procedure drawSky(camx, camy:integer);
  var
   s_x, s_y:integer;
   s_w, s_h:integer;
   scr_w, scr_h:integer;
   map_w, map_h:integer;
  begin
   s_w:=getImageWidth(sky);
   s_h:=getImageHeight(sky);
   scr_w:=getWidth;
   scr_h:=getHeight;
   map_w:=getMapW*TILE_SIZE;
   map_h:=getMapH*TILE_SIZE;

   setColor($00, $00, $00);
   fillRect(0, 0, scr_w, scr_h);

   s_x:=-(camx*(s_w-scr_w)/(map_w-scr_w));
   s_y:=-(camy*(s_h-scr_h)/(map_h-scr_h));

   drawImage(sky, s_x, s_y);
  end;

initialization
 
end.
